#include <cstdio>
#include <vector>
using namespace std;

//  dfs           ,    v,
//          :
// v   ,       
// graph      (graph[v]     v )
// visited       (visited[w] == true    ,   w  )
//          v
int dfs(int v, vector<vector<int> > const &graph, vector<bool> &visited)
{
    visited[v] = true;
    int result = graph[v].size() % 2; //  1      ,    v 
    for (int i = 0; i < graph[v].size(); i++)
    {
        if (!visited[graph[v][i]]) //      v ,    ,
        {                          //       
            result += dfs(graph[v][i], graph, visited);
        }
    }
    return result;
}

int main()
{
    freopen("streets.in", "r", stdin);
    freopen("streets.out", "w", stdout);

    int n, m;
    scanf("%d%d", &n, &m);

    vector<vector<int> > graph(n); // graph[v]     v 
    vector<bool> visited(n, false); // visited[v]  true,   v     

    //  :
    for (int i = 0; i < m; i++)
    {
        int a, b;
        scanf("%d%d", &a, &b);
        graph[a - 1].push_back(b - 1); //        
        graph[b - 1].push_back(a - 1);
    }

    int ans = 0;
    for (int v = 0; v < n; v++)
    {
        if (!visited[v]) //   ,       ,    ,
        {                //           
            ans += max(dfs(v, graph, visited) / 2, 1); //    0,       1
        }
    }

    printf("%d\n", ans);
}